#include <adventure-pack/ap-ability.h>

#include <glib.h>

int
main (int    argc,
      char **argv)
{
    APAbility *ability;
    gchar *name;
    gchar *label;
    gint score;
    gint modifier;

    /* Ability Baseline Test */
    ability = g_object_new (AP_TYPE_ABILITY,
                            "name", "strength",
                            "label", "Strength",
                            "score", 10,
                            "bonus", 0,
                            NULL);

    name = ap_ability_get_name (ability);
    label = ap_ability_get_label (ability);
    score = ap_ability_get_bonus (ability);

    g_assert_cmpstr (name, ==, "strength");
    g_assert_cmpstr (label, ==, "Strength");
    g_assert_cmpint (score, ==, 10);

    /* Ability Score with Bonus Test */
    ability = g_object_new (AP_TYPE_ABILITY,
                            "name", "dexterity",
                            "label", "Dexterity",
                            "score", 10,
                            "bonus", 3,
                            NULL);

    score = ap_ability_get_bonus (ability);

    g_assert_cmpint (score, ==, 13);

    /* Ability Modifier Test */
    for (int i = 1; i <  30; i++)
    {
        ability = g_object_new (AP_TYPE_ABILITY,
                                "score", 10,
                                NULL);

        score = ap_ability_get_bonus (ability);
        modifier = ap_ability_get_modifier (ability);

        if (score == 1)
            g_assert_cmpint (modifier, ==, -5);
        else if (score == 2 || score == 3)
            g_assert_cmpint (modifier, ==, -4);
        else if (score == 4 || score == 5)
            g_assert_cmpint (modifier, ==, -3);
        else if (score == 6 || score == 7)
            g_assert_cmpint (modifier, ==, -2);
        else if (score == 8 || score == 9)
            g_assert_cmpint (modifier, ==, -1);
        else if (score == 10 || score == 11)
            g_assert_cmpint (modifier, ==, 0);
        else if (score == 12 || score == 13)
            g_assert_cmpint (modifier, ==, 1);
        else if (score == 14 || score == 15)
            g_assert_cmpint (modifier, ==, 2);
        else if (score == 16 || score == 17)
            g_assert_cmpint (modifier, ==, 3);
        else if (score == 18 || score == 19)
            g_assert_cmpint (modifier, ==, 4);
        else if (score == 20 || score == 21)
            g_assert_cmpint (modifier, ==, 5);
        else if (score == 22 || score == 23)
            g_assert_cmpint (modifier, ==, 6);
        else if (score == 24 || score == 25)
            g_assert_cmpint (modifier, ==, 7);
        else if (score == 26 || score == 27)
            g_assert_cmpint (modifier, ==, 8);
        else if (score == 28 || score == 29)
            g_assert_cmpint (modifier, ==, 9);
        else if (score == 30)
            g_assert_cmpint (modifier, ==, 10);
        else
            g_warning ("Score out of 1 - 30 range, is: %i", score);
    }

    return 0;
}
